//draw the points and lines in the edge of every circle to represent the books.

void drawBooks(boolean showCountry, ArrayList<Book> books) {

  if (showCountry == true) {
    for (int i = 0; i< books.size(); i++) {
      Book theBook = books.get(i);
      String[] dates = split(theBook.date, '-');
      int year = int(dates[0]);

      //skip to next drawing cycle if the date not meet requirement
      if ( year < 2006 || year > 2021) {
        continue;
      }

      // calculate the book coordinate accroding to the pointCoordinate function
      PVector pCoordinate = pointCoordinate(theBook.country, theBook.date);
      float x, y, z;
      x = pCoordinate.x;
      y = pCoordinate.y;
      z = pCoordinate.z;

      /* project 3D coordinates in the 2D screenspace */
      float d_x = screenX(x, y, z);
      float d_y = screenY(x, y, z);

      /* calculate the distance between (d_x, d_y) , (mouseX, mouseY) */
      float distanceObjectMouse = sq(d_x - mouseX) + sq(d_y-mouseY);
      color c = colorDetermine(theBook.country);

      stroke(c);
      point(x, y, z);
      line(x, y, z, x, y, z + theBook.count * 5);

      // draw title if the mouse is near the dots
      if (distanceObjectMouse < 20) {
        strokeWeight(15);
      } else {
        strokeWeight(4);
      }

      if (distanceObjectMouse < 20) {
        fill(255);
        /* draw large text first */
        textSize(20);
        pushMatrix();
        translate(x, y, z);
        /* scale the text down to 0.5x size*/
        scale(0.4);
        textAlign(LEFT, CENTER);
        /* draw the title a little to the right of the dots */
        text("Title: " + theBook.title + "\n" + "Count:" + theBook.count + "\n" + theBook.date, 10, 0, 0);
        popMatrix();
      }
    }
  }
}
