void radiusCalculate(Table table1, Table table2) {
  numRows1 = table1.getRowCount();
  numRows2 = table2.getRowCount();

  counts = new int[numRows1][5];
  radius = new int[numRows1][5];

  for (int i=0; i<numRows1; i++) {
    //create a 2d array to store the total counts for five countries
    for (int j = 1; j < 6; j++) {
      counts[i][j-1] = table1.getInt(i, j);
      //println(counts[i][j-1]);
    }
    smallest = min(counts[i]);
    largest = max(counts[i]);
    //calculate the radius of the circle
    for (int j = 0; j < 5; j++) {
      radius[i][j] = int(map(counts[i][j], smallest, largest, 30, 150));
      //println(radius[i][j]);
    }
  }
}

void booksConstruction(Table table2) {
  for (int i=0; i<numRows2; i++) {
    String country = table2.getString(i, 0);
    String bibNumber = table2.getString(i, 1);
    String date = table2.getString(i, 2);
    String title = table2.getString(i, 3);
    int count = table2.getInt(i, 4);
    Book newBook = new Book(country, bibNumber, date, title, count);
    //books.add(newBook);
    if (newBook.country.equals("China")) {
      cBooks.add(newBook);
    }
    if (newBook.country.equals("Japan")) {
      jBooks.add(newBook);
    }
    if (newBook.country.equals("India")) {
      iBooks.add(newBook);
    }
    if (newBook.country.equals("Korea")) {
      kBooks.add(newBook);
    }
    if (newBook.country.equals("Vietnam")) {
      vBooks.add(newBook);
    }
  }
}


color colorDetermine(String country) {
  color c = #FFFFFF;
  if (country.equals("China")) {
    c = #FF0033;
  } else if (country.equals("India")) {
    c = #FFFF33;
  } else if (country.equals("Japan")) {
    c = #0000FF;
  } else if (country.equals("Korea")) {
    c = #14E3CE;
  } else if (country.equals("Vietnam")) {
    c = #C714E3;
  }
  return c;
}

PVector pointCoordinate(String country, String rawDate) {
  float point_x, point_y, point_z;
  String[] dates = split(rawDate, '-');
  int year = int(dates[0]);
  int month = int(dates[1]);
  int day = int(dates[2]);

  int i = year - 2006;
  HashMap<String, Integer> map = new HashMap<>();
  map.put("China", 0);
  map.put("India", 1);
  map.put("Japan", 2);
  map.put("Korea", 3);
  map.put("Vietnam", 4);
  int j = map.get(country);
  int r = radius[i][j];

  float degree = 360 - ((month-1)*30 + day);
  point_x =  r/2 * cos(radians(degree));
  point_y =  -r/2 * sin(radians(degree));
  point_z = -120*i;

  PVector pCoordinate = new PVector(point_x, point_y, point_z);

  return pCoordinate;
}

void keyPressed() {
  if (key == 'c' || key == 'C') {
    showChina = !showChina;
  }
  if (key == 'j' || key == 'J') {
    showJapan = !showJapan;
  }
  if (key == 'i' || key == 'I') {
    showIndia = !showIndia;
  }
  if (key == 'k' || key == 'K') {
    showKorea = !showKorea;
  }
  if (key == 'v' || key == 'V') {
    showVietnam = !showVietnam;
  }
  if (key == '1') {
    showCurve = !showCurve;
  }
}


void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();

  pushMatrix();
  textAlign(LEFT, CENTER);
  fill(255);
  textFont(f, 15);
  text("READING INTERESTS ON FIVE ASIAN COUNTRIES"+"\n"+"IN SEATLE'S LIBRIARY"+"\n" +"FROM 2006 to 2021", 60, 80);
  popMatrix();

  pushMatrix();
  textAlign(LEFT, CENTER);
  fill(255);
  textFont(f, 15);
  text("Press 1 to show curves", 60, height-320);
  popMatrix();
  
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

void controlEvent(ControlEvent theEvent) {
  int id = theEvent.getController().getId();
  if (id==0) {
    showChina =!showChina;
  } else if (id==1) {
    showIndia = !showIndia;
  } else if (id==2) {
    showJapan = !showJapan;
  } else if (id==3) {
    showKorea = !showKorea;
  } else if (id==4) {
    showVietnam =!showVietnam;
  }
}
